PIP-INSTALL(1)

NAME
pip-install - description of pip install command

DESCRIPTION

Install packages from:

•   PyPI (and other indexes) using requirement specifiers.

•   VCS project urls.

•   Local project directories.

•   Local or remote source archives.

    pip also supports installing from "requirements files", which provide an easy way to specify a whole environment to be installed.

USAGE

python -m pip install [options] <requirement specifier> [package-index-options] ...
python -m pip install [options] -r <requirements file> [package-index-options] ...
python -m pip install [options] [-e] <vcs project url> ...
python -m pip install [options] [-e] <local project path> ...
python -m pip install [options] <archive url/path> ...

OPTIONS

-r, --requirement <file>
    Install from the given requirements file. This option can be used multiple times.

-c, --constraint <file>
    Constrain versions using the given constraints file. This option can be used multiple times.

--no-deps
    Don't install package dependencies.

--pre
    Include pre-release and development versions. By default, pip only finds stable versions.

-e, --editable <path/url>
    Install a project in editable mode (i.e. setuptools "develop mode") from a local project path or a VCS url.

--dry-run
    Don't actually install anything, just print what would be. Can be used in combination with --ignore-installed to 'resolve' the requirements.

-t, --target <dir>
    Install packages into <dir>. By default this will not replace existing files/folders in <dir>. Use --upgrade to replace existing packages in <dir> with new versions.

--platform <platform>
    Only use wheels compatible with <platform>. Defaults to the platform of the running system. Use this option multiple times to specify multiple platforms supported by the target interpreter.

--python-version <python_version>
    The Python interpreter version to use for wheel and "Requires-Python" compatibility checks. Defaults to a version derived from the running interpreter. The version can be specified using up to three dot-separated integers (e.g. "3" for 3.0.0, "3.7" for 3.7.0, or "3.7.3"). A major-minor version can also be given as a string without dots (e.g. "37" for 3.7.0).

--implementation <implementation>
    Only use wheels compatible with Python implementation <implementation>, e.g. 'pp', 'jy', 'cp', or 'ip'. If not specified, then the current interpreter implementation is used. Use 'py' to force implementation-agnostic wheels.

--abi <abi>
    Only use wheels compatible with Python abi <abi>, e.g. 'pypy_41'. If not specified, then the current interpreter abi tag is used. Use this option multiple times to specify multiple abis supported by the target interpreter. Generally you will need to specify --implementation, --platform, and --python-version when using this option.

--user
    Install to the Python user install directory for your platform. Typically ~/.local/, or %APPDATA%Python on Windows. (See the Python documentation for site.USER_BASE for full details.)

--root <dir>
    Install everything relative to this alternate root directory.

--prefix <dir>
    Installation prefix where lib, bin and other top-level folders are placed. Note that the resulting installation may contain scripts and other resources which reference the Python interpreter of pip, and not that of --prefix. See also the --python option if the intention is to install packages into another (possibly pip-free) environment.

--src <dir>
    Directory to check out editable projects into. The default in a virtualenv is "<venv path>/src". The default for global installs is "<current dir>/src".

-U, --upgrade
    Upgrade all specified packages to the newest available version. The handling of dependencies depends on the upgrade-strategy used.

--upgrade-strategy <upgrade_strategy>
    Determines how dependency upgrading should be handled [default: only-if-needed]. "eager" - dependencies are upgraded regardless of whether the currently installed version satisfies the requirements of the upgraded package(s). "only-if-needed" - are upgraded only when they do not satisfy the requirements of the upgraded package(s).

--force-reinstall
    Reinstall all packages even if they are already up-to-date.

-I, --ignore-installed
    Ignore the installed packages, overwriting them. This can break your system if the existing package is of a different version or was installed with a different package manager!

--ignore-requires-python
    Ignore the Requires-Python information.

--no-build-isolation
    Disable isolation when building a modern source distribution. Build dependencies specified by PEP 518 must be already installed if this option is used.

--use-pep517
    Use PEP 517 for building source distributions (use --no-use-pep517 to force legacy behaviour).

--check-build-dependencies
    Check the build dependencies when PEP517 is used.

--break-system-packages
    Allow pip to modify an EXTERNALLY-MANAGED Python installation

-C, --config-settings <settings>
    Configuration settings to be passed to the PEP 517 build backend. Settings take the form KEY=VALUE. Use multiple --config-settings options to pass multiple keys to the backend.

--global-option <options>
    Extra global options to be supplied to the setup.py call before the install or bdist_wheel command.

--compile
    Compile Python source files to bytecode

--no-compile
    Do not compile Python source files to bytecode

--no-warn-script-location
    Do not warn when installing scripts outside PATH

--no-warn-conflicts
    Do not warn about broken dependencies

--no-binary <format_control>
    Do not use binary packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either ":all:" to disable all binary packages, ":none:" to empty the set (notice the colons), or one or more package names with commas between them (no colons). Note that some packages are tricky to compile and may fail to install when this option is used on them.

--only-binary <format_control>
    Do not use source packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either ":all:" to disable all source packages, ":none:" to empty the set, or one or more package names with commas between them. Packages without binary distributions will fail to install when this option is used on them.

--prefer-binary
    Prefer binary packages over source packages, even if the source packages are newer.

--require-hashes
    Require a hash to check each requirement against, for repeatable installs. This option is implied when any package in a requirements file has a --hash option.

--progress-bar <progress_bar>
    Specify whether the progress bar should be used [on, off] (default: on)

--root-user-action <root_user_action>
    Action if pip is run as a root user. By default, a warning message is shown.

--report <file>
    Generate a JSON file describing what pip did to install the provided requirements. Can be used in combination with --dry-run and --ignore-installed to 'resolve' the requirements. When - is used as file name it writes to stdout. When writing to stdout, please combine with the --quiet option to avoid mixing pip logging output with JSON output.

--no-clean
    Don't clean up build directories.

AUTHOR
pip developers

COPYRIGHT
The pip developers